Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -1050,23 +998,24 @@
 !
 !-- Allocate wall and roof material parameters. First for horizontal surfaces
-    ALLOCATE ( surf_usm_h%thickness_wall(1:surf_usm_h%ns)                    )
-    ALLOCATE ( surf_usm_h%thickness_window(1:surf_usm_h%ns)                  )
-    ALLOCATE ( surf_usm_h%thickness_green(1:surf_usm_h%ns)                   )
-    ALLOCATE ( surf_usm_h%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h%ns)        )
-    ALLOCATE ( surf_usm_h%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h%ns)      )
-    ALLOCATE ( surf_usm_h%lambda_h_window(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%rho_c_window(nzb_wall:nzt_wall,1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%lambda_h_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%rho_c_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
-
-    ALLOCATE ( surf_usm_h%rho_c_total_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%n_vg_green(1:surf_usm_h%ns)                             )
-    ALLOCATE ( surf_usm_h%alpha_vg_green(1:surf_usm_h%ns)                         )
-    ALLOCATE ( surf_usm_h%l_vg_green(1:surf_usm_h%ns)                             )
-    ALLOCATE ( surf_usm_h%gamma_w_green_sat(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%lambda_w_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)       )
-    ALLOCATE ( surf_usm_h%gamma_w_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)        )
-    ALLOCATE ( surf_usm_h%tswc_h_m(nzb_wall:nzt_wall,1:surf_usm_h%ns)             )
-
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%thickness_wall(1:surf_usm_h(l)%ns)                    )
+       ALLOCATE ( surf_usm_h(l)%thickness_window(1:surf_usm_h(l)%ns)                  )
+       ALLOCATE ( surf_usm_h(l)%thickness_green(1:surf_usm_h(l)%ns)                   )
+       ALLOCATE ( surf_usm_h(l)%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)        )
+       ALLOCATE ( surf_usm_h(l)%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)      )
+       ALLOCATE ( surf_usm_h(l)%lambda_h_window(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%rho_c_window(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%lambda_h_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%rho_c_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)     )
+
+       ALLOCATE ( surf_usm_h(l)%rho_c_total_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%n_vg_green(1:surf_usm_h(l)%ns)                             )
+       ALLOCATE ( surf_usm_h(l)%alpha_vg_green(1:surf_usm_h(l)%ns)                         )
+       ALLOCATE ( surf_usm_h(l)%l_vg_green(1:surf_usm_h(l)%ns)                             )
+       ALLOCATE ( surf_usm_h(l)%gamma_w_green_sat(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%lambda_w_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)       )
+       ALLOCATE ( surf_usm_h(l)%gamma_w_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)        )
+       ALLOCATE ( surf_usm_h(l)%tswc_h_m(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)             )
+    ENDDO
 !
 !-- For vertical surfaces.
@@ -1085,12 +1034,13 @@
 !
 !-- Allocate green wall and roof vegetation and soil parameters. First horizontal surfaces
-    ALLOCATE ( surf_usm_h%g_d(1:surf_usm_h%ns)              )
-    ALLOCATE ( surf_usm_h%c_liq(1:surf_usm_h%ns)            )
-    ALLOCATE ( surf_usm_h%qsws_liq(1:surf_usm_h%ns)         )
-    ALLOCATE ( surf_usm_h%qsws_veg(1:surf_usm_h%ns)         )
-    ALLOCATE ( surf_usm_h%r_canopy(1:surf_usm_h%ns)         )
-    ALLOCATE ( surf_usm_h%r_canopy_min(1:surf_usm_h%ns)     )
-    ALLOCATE ( surf_usm_h%pt_10cm(1:surf_usm_h%ns)          )
-
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%g_d(1:surf_usm_h(l)%ns)              )
+       ALLOCATE ( surf_usm_h(l)%c_liq(1:surf_usm_h(l)%ns)            )
+       ALLOCATE ( surf_usm_h(l)%qsws_liq(1:surf_usm_h(l)%ns)         )
+       ALLOCATE ( surf_usm_h(l)%qsws_veg(1:surf_usm_h(l)%ns)         )
+       ALLOCATE ( surf_usm_h(l)%r_canopy(1:surf_usm_h(l)%ns)         )
+       ALLOCATE ( surf_usm_h(l)%r_canopy_min(1:surf_usm_h(l)%ns)     )
+       ALLOCATE ( surf_usm_h(l)%pt_10cm(1:surf_usm_h(l)%ns)          )
+    ENDDO
 !
 !-- For vertical surfaces.
@@ -1107,22 +1057,21 @@
 !
 !-- Allocate wall and roof layers sizes. For horizontal surfaces.
-    ALLOCATE ( zwn(nzb_wall:nzt_wall)                                        )
-    ALLOCATE ( surf_usm_h%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)       )
-    ALLOCATE ( zwn_window(nzb_wall:nzt_wall)                                 )
-    ALLOCATE ( surf_usm_h%dz_window(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
-    ALLOCATE ( zwn_green(nzb_wall:nzt_wall)                                  )
-    ALLOCATE ( surf_usm_h%dz_green(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)      )
-    ALLOCATE ( surf_usm_h%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)      )
-    ALLOCATE ( surf_usm_h%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
-    ALLOCATE ( surf_usm_h%zw(nzb_wall:nzt_wall,1:surf_usm_h%ns)              )
-    ALLOCATE ( surf_usm_h%ddz_window(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%dz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%ddz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%zw_window(nzb_wall:nzt_wall,1:surf_usm_h%ns)       )
-    ALLOCATE ( surf_usm_h%ddz_green(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
-    ALLOCATE ( surf_usm_h%dz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
-    ALLOCATE ( surf_usm_h%ddz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%zw_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)        )
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)       )
+       ALLOCATE ( surf_usm_h(l)%dz_window(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)     )
+       ALLOCATE ( surf_usm_h(l)%dz_green(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)      )
+       ALLOCATE ( surf_usm_h(l)%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)      )
+       ALLOCATE ( surf_usm_h(l)%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)   )
+       ALLOCATE ( surf_usm_h(l)%zw(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)              )
+       ALLOCATE ( surf_usm_h(l)%ddz_window(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%dz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%ddz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%zw_window(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)       )
+       ALLOCATE ( surf_usm_h(l)%ddz_green(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)     )
+       ALLOCATE ( surf_usm_h(l)%dz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)   )
+       ALLOCATE ( surf_usm_h(l)%ddz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%zw_green(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns)        )
+    ENDDO
 
 !
@@ -1149,48 +1098,49 @@
 !-- Allocate wall and roof temperature arrays, for horizontal walls.
 !-- Allocate if required. Note, in case of restarts, some of these arrays might be already allocated.
-    IF ( .NOT. ALLOCATED( t_surf_wall_h_1 ) )                                                      &
-       ALLOCATE ( t_surf_wall_h_1(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_surf_wall_h_2 ) )                                                      &
-       ALLOCATE ( t_surf_wall_h_2(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_wall_h_1 ) )                                                           &
-       ALLOCATE ( t_wall_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_wall_h_2 ) )                                                           &
-       ALLOCATE ( t_wall_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_surf_window_h_1 ) )                                                    &
-       ALLOCATE ( t_surf_window_h_1(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_surf_window_h_2 ) )                                                    &
-       ALLOCATE ( t_surf_window_h_2(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_window_h_1 ) )                                                         &
-       ALLOCATE ( t_window_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_window_h_2 ) )                                                         &
-       ALLOCATE ( t_window_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_surf_green_h_1 ) )                                                     &
-       ALLOCATE ( t_surf_green_h_1(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_surf_green_h_2 ) )                                                     &
-       ALLOCATE ( t_surf_green_h_2(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_green_h_1 ) )                                                          &
-       ALLOCATE ( t_green_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( t_green_h_2 ) )                                                          &
-       ALLOCATE ( t_green_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( swc_h_1 ) )                                                              &
-       ALLOCATE ( swc_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( swc_sat_h_1 ) )                                                          &
-       ALLOCATE ( swc_sat_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( swc_res_h_1 ) )                                                          &
-       ALLOCATE ( swc_res_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( swc_h_2 ) )                                                              &
-       ALLOCATE ( swc_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( rootfr_h_1 ) )                                                           &
-       ALLOCATE ( rootfr_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( wilt_h_1 ) )                                                             &
-       ALLOCATE ( wilt_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( fc_h_1 ) )                                                               &
-       ALLOCATE ( fc_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-
-    IF ( .NOT. ALLOCATED( m_liq_usm_h_1%var_usm_1d ) )                                             &
-       ALLOCATE ( m_liq_usm_h_1%var_usm_1d(1:surf_usm_h%ns) )
-    IF ( .NOT. ALLOCATED( m_liq_usm_h_2%var_usm_1d ) )                                             &
-       ALLOCATE ( m_liq_usm_h_2%var_usm_1d(1:surf_usm_h%ns) )
-
+    DO l = 0, 1
+       IF ( .NOT. ALLOCATED( t_surf_wall_h_1(l)%val ) )                                                      &
+          ALLOCATE ( t_surf_wall_h_1(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_wall_h_2(l)%val ) )                                                      &
+          ALLOCATE ( t_surf_wall_h_2(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_wall_h_1(l)%val ) )                                                           &
+          ALLOCATE ( t_wall_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_wall_h_2(l)%val ) )                                                           &
+          ALLOCATE ( t_wall_h_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_window_h_1(l)%val ) )                                                    &
+          ALLOCATE ( t_surf_window_h_1(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_window_h_2(l)%val ) )                                                    &
+          ALLOCATE ( t_surf_window_h_2(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_window_h_1(l)%val ) )                                                         &
+          ALLOCATE ( t_window_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_window_h_2(l)%val ) )                                                         &
+          ALLOCATE ( t_window_h_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_green_h_1(l)%val ) )                                                     &
+          ALLOCATE ( t_surf_green_h_1(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_green_h_2(l)%val ) )                                                     &
+          ALLOCATE ( t_surf_green_h_2(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_green_h_1(l)%val ) )                                                          &
+          ALLOCATE ( t_green_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_green_h_2(l)%val ) )                                                          &
+          ALLOCATE ( t_green_h_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( swc_h_1(l)%val ) )                                                              &
+          ALLOCATE ( swc_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( swc_sat_h_1(l)%val ) )                                                          &
+          ALLOCATE ( swc_sat_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( swc_res_h_1(l)%val ) )                                                          &
+          ALLOCATE ( swc_res_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( swc_h_2(l)%val ) )                                                              &
+          ALLOCATE ( swc_h_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( rootfr_h_1(l)%val ) )                                                           &
+          ALLOCATE ( rootfr_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( wilt_h_1(l)%val ) )                                                             &
+          ALLOCATE ( wilt_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( fc_h_1(l)%val ) )                                                               &
+          ALLOCATE ( fc_h_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+
+       IF ( .NOT. ALLOCATED( m_liq_usm_h_1(l)%val ) )                                             &
+          ALLOCATE ( m_liq_usm_h_1(l)%val(1:surf_usm_h(l)%ns) )
+       IF ( .NOT. ALLOCATED( m_liq_usm_h_2(l)%val ) )                                             &
+          ALLOCATE ( m_liq_usm_h_2(l)%val(1:surf_usm_h(l)%ns) )
+    ENDDO
 !
 !-- Initial assignment of the pointers
@@ -1213,28 +1163,28 @@
 !-- Allocate if required. Note, in case of restarts, some of these arrays might be already allocated.
     DO  l = 0, 3
-       IF ( .NOT. ALLOCATED( t_surf_wall_v_1(l)%t ) )                                              &
-          ALLOCATE ( t_surf_wall_v_1(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_surf_wall_v_2(l)%t ) )                                              &
-          ALLOCATE ( t_surf_wall_v_2(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_wall_v_1(l)%t ) )                                                   &
-          ALLOCATE ( t_wall_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_wall_v_2(l)%t ) )                                                   &
-          ALLOCATE ( t_wall_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_surf_window_v_1(l)%t ) )                                            &
-          ALLOCATE ( t_surf_window_v_1(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_surf_window_v_2(l)%t ) )                                            &
-          ALLOCATE ( t_surf_window_v_2(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_window_v_1(l)%t ) )                                                 &
-          ALLOCATE ( t_window_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_window_v_2(l)%t ) )                                                 &
-          ALLOCATE ( t_window_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_surf_green_v_1(l)%t ) )                                             &
-          ALLOCATE ( t_surf_green_v_1(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_surf_green_v_2(l)%t ) )                                             &
-          ALLOCATE ( t_surf_green_v_2(l)%t(1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_green_v_1(l)%t ) )                                                  &
-          ALLOCATE ( t_green_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-       IF ( .NOT. ALLOCATED( t_green_v_2(l)%t ) )                                                  &
-          ALLOCATE ( t_green_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_wall_v_1(l)%val ) )                                              &
+          ALLOCATE ( t_surf_wall_v_1(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_wall_v_2(l)%val ) )                                              &
+          ALLOCATE ( t_surf_wall_v_2(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_wall_v_1(l)%val ) )                                                   &
+          ALLOCATE ( t_wall_v_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_wall_v_2(l)%val ) )                                                   &
+          ALLOCATE ( t_wall_v_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_window_v_1(l)%val ) )                                            &
+          ALLOCATE ( t_surf_window_v_1(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_window_v_2(l)%val ) )                                            &
+          ALLOCATE ( t_surf_window_v_2(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_window_v_1(l)%val ) )                                                 &
+          ALLOCATE ( t_window_v_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_window_v_2(l)%val ) )                                                 &
+          ALLOCATE ( t_window_v_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_green_v_1(l)%val ) )                                             &
+          ALLOCATE ( t_surf_green_v_1(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_surf_green_v_2(l)%val ) )                                             &
+          ALLOCATE ( t_surf_green_v_2(l)%val(1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_green_v_1(l)%val ) )                                                  &
+          ALLOCATE ( t_green_v_1(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+       IF ( .NOT. ALLOCATED( t_green_v_2(l)%val ) )                                                  &
+          ALLOCATE ( t_green_v_2(l)%val(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
     ENDDO
 !
@@ -1249,24 +1199,25 @@
 !
 !-- Allocate intermediate timestep arrays. For horizontal surfaces.
-    ALLOCATE ( surf_usm_h%tt_surface_wall_m(1:surf_usm_h%ns)               )
-    ALLOCATE ( surf_usm_h%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)   )
-    ALLOCATE ( surf_usm_h%tt_surface_window_m(1:surf_usm_h%ns)             )
-    ALLOCATE ( surf_usm_h%tt_window_m(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%tt_green_m(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%tt_surface_green_m(1:surf_usm_h%ns)              )
-
-!
-!-- Allocate intermediate timestep arrays
-!-- Horizontal surfaces
-    ALLOCATE ( tm_liq_usm_h_m%var_usm_1d(1:surf_usm_h%ns) )
-    tm_liq_usm_h_m%var_usm_1d = 0.0_wp
-!
-!-- Set inital values for prognostic quantities
-    IF ( ALLOCATED( surf_usm_h%tt_surface_wall_m )   )  surf_usm_h%tt_surface_wall_m   = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%tt_wall_m )           )  surf_usm_h%tt_wall_m           = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%tt_surface_window_m ) )  surf_usm_h%tt_surface_window_m = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%tt_window_m    )      )  surf_usm_h%tt_window_m         = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%tt_green_m    )       )  surf_usm_h%tt_green_m          = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%tt_surface_green_m )  )  surf_usm_h%tt_surface_green_m  = 0.0_wp
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%tt_surface_wall_m(1:surf_usm_h(l)%ns)               )
+       ALLOCATE ( surf_usm_h(l)%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)   )
+       ALLOCATE ( surf_usm_h(l)%tt_surface_window_m(1:surf_usm_h(l)%ns)             )
+       ALLOCATE ( surf_usm_h(l)%tt_window_m(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%tt_green_m(nzb_wall:nzt_wall+1,1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%tt_surface_green_m(1:surf_usm_h(l)%ns)              )
+!
+!--    Allocate intermediate timestep arrays
+!--    Horizontal surfaces
+       ALLOCATE ( tm_liq_usm_h_m(l)%val(1:surf_usm_h(l)%ns) )
+       tm_liq_usm_h_m(l)%val = 0.0_wp
+!
+!--    Set inital values for prognostic quantities
+       IF ( ALLOCATED( surf_usm_h(l)%tt_surface_wall_m )   )  surf_usm_h(l)%tt_surface_wall_m   = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%tt_wall_m )           )  surf_usm_h(l)%tt_wall_m           = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%tt_surface_window_m ) )  surf_usm_h(l)%tt_surface_window_m = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%tt_window_m    )      )  surf_usm_h(l)%tt_window_m         = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%tt_green_m    )       )  surf_usm_h(l)%tt_green_m          = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%tt_surface_green_m )  )  surf_usm_h(l)%tt_surface_green_m  = 0.0_wp
+    END DO
 !
 !-- Now, for vertical surfaces
@@ -1287,20 +1238,22 @@
 !
 !-- Allocate wall heat flux output arrays and set initial values. For horizontal surfaces
-!    ALLOCATE ( surf_usm_h%wshf(1:surf_usm_h%ns)    )  !can be removed
-    ALLOCATE ( surf_usm_h%ghf(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%wshf_eb(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%wghf_eb(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%wghf_eb_window(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%wghf_eb_green(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%iwghf_eb(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%iwghf_eb_window(1:surf_usm_h%ns) )
-    IF ( ALLOCATED( surf_usm_h%ghf     ) )  surf_usm_h%ghf     = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%wshf    ) )  surf_usm_h%wshf    = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%wshf_eb ) )  surf_usm_h%wshf_eb = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%wghf_eb ) )  surf_usm_h%wghf_eb = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%wghf_eb_window ) )   surf_usm_h%wghf_eb_window  = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%wghf_eb_green ) )    surf_usm_h%wghf_eb_green   = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%iwghf_eb ) )         surf_usm_h%iwghf_eb        = 0.0_wp
-    IF ( ALLOCATED( surf_usm_h%iwghf_eb_window ) )  surf_usm_h%iwghf_eb_window = 0.0_wp
+    DO  l = 0, 1
+!      ALLOCATE ( surf_usm_h(l)%wshf(1:surf_usm_h(l)%ns)    )  !can be removed
+       ALLOCATE ( surf_usm_h(l)%ghf(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%wshf_eb(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%wghf_eb(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%wghf_eb_window(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%wghf_eb_green(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%iwghf_eb(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%iwghf_eb_window(1:surf_usm_h(l)%ns) )
+       IF ( ALLOCATED( surf_usm_h(l)%ghf     ) )  surf_usm_h(l)%ghf     = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%wshf    ) )  surf_usm_h(l)%wshf    = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%wshf_eb ) )  surf_usm_h(l)%wshf_eb = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%wghf_eb ) )  surf_usm_h(l)%wghf_eb = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%wghf_eb_window ) )   surf_usm_h(l)%wghf_eb_window  = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%wghf_eb_green ) )    surf_usm_h(l)%wghf_eb_green   = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%iwghf_eb ) )         surf_usm_h(l)%iwghf_eb        = 0.0_wp
+       IF ( ALLOCATED( surf_usm_h(l)%iwghf_eb_window ) )  surf_usm_h(l)%iwghf_eb_window = 0.0_wp
+    ENDDO
 !
 !-- Now, for vertical surfaces
@@ -1348,12 +1301,7 @@
     INTEGER(iwp)                                       ::  i, j, k, l, m, ids, idsint, iwl, istat  !< runnin indices
     CHARACTER(LEN=varnamelength)                       ::  var                                     !< trimmed variable
-    INTEGER(iwp), PARAMETER                            ::  nd = 5                                  !< number of directions
-    CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER     ::  dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint = (/ iup, isouth, inorth, iwest, ieast /)
-
-
-
-
-    IF ( variable(1:4) == 'usm_' )  THEN  ! Is such a check really required?
+    LOGICAL                                            ::  horizontal
+
+    IF ( .NOT. variable(1:4) == 'usm_' )  RETURN  ! Is such a check really required?
 
 !
@@ -1368,26 +1316,30 @@
            ids = i
            idsint = dirint(ids)
+           l = diridx(ids)  !> index of direction for _h and _v arrays
            var = var(:k-j)
            EXIT
        ENDIF
     ENDDO
-    l = idsint - 2  ! Horizontal direction index - terrible hack !
-    IF ( l < 0 .OR. l > 3 )  THEN
-       l = -1
-    ENDIF
     IF ( ids == -1 )  THEN
         var = TRIM( variable )
+    ELSE
+!--    Horizontal direction flag
+       IF ( idsint == iup .OR. idsint == idown )  THEN
+          horizontal = .TRUE.
+       ELSE
+          horizontal = .FALSE.
+       ENDIF
     ENDIF
     IF ( var(1:11) == 'usm_t_wall_'  .AND.  len( TRIM( var ) ) >= 12 )  THEN
 !
-!--      Wall layers
-        READ( var(12:12), '(I1)', iostat=istat ) iwl
-        IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
-            var = var(1:10)
-        ELSE
-!
-!--         Wrong wall layer index
-            RETURN
-        ENDIF
+!--    Wall layers
+       READ( var(12:12), '(I1)', iostat=istat ) iwl
+       IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
+          var = var(1:10)
+       ELSE
+!
+!--       Wrong wall layer index
+          RETURN
+       ENDIF
     ENDIF
     IF ( var(1:13) == 'usm_t_window_'  .AND.  len( TRIM(var) ) >= 14 )  THEN
@@ -1436,8 +1388,8 @@
 !--             Array of sensible heat flux from surfaces
 !--             Land surfaces
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%wshf_eb_av ) )  THEN
-                      ALLOCATE ( surf_usm_h%wshf_eb_av(1:surf_usm_h%ns) )
-                      surf_usm_h%wshf_eb_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%wshf_eb_av ) )  THEN
+                      ALLOCATE ( surf_usm_h(l)%wshf_eb_av(1:surf_usm_h(l)%ns) )
+                      surf_usm_h(l)%wshf_eb_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1452,7 +1404,7 @@
 !--             Array of latent heat flux from surfaces
 !--             Land surfaces
-                IF ( l == -1 .AND. .NOT.  ALLOCATED( surf_usm_h%qsws_av ) )  THEN
-                    ALLOCATE ( surf_usm_h%qsws_av(1:surf_usm_h%ns) )
-                    surf_usm_h%qsws_av = 0.0_wp
+                IF ( horizontal .AND. .NOT.  ALLOCATED( surf_usm_h(l)%qsws_av ) )  THEN
+                    ALLOCATE ( surf_usm_h(l)%qsws_av(1:surf_usm_h(l)%ns) )
+                    surf_usm_h(l)%qsws_av = 0.0_wp
                 ELSE
                    IF ( .NOT.  ALLOCATED( surf_usm_v(l)%qsws_av ) )  THEN
@@ -1466,7 +1418,7 @@
 !--             Array of latent heat flux from vegetation surfaces
 !--             Land surfaces
-                IF ( l == -1 .AND. .NOT.  ALLOCATED( surf_usm_h%qsws_veg_av ) )  THEN
-                    ALLOCATE ( surf_usm_h%qsws_veg_av(1:surf_usm_h%ns) )
-                    surf_usm_h%qsws_veg_av = 0.0_wp
+                IF ( horizontal .AND. .NOT.  ALLOCATED( surf_usm_h(l)%qsws_veg_av ) )  THEN
+                    ALLOCATE ( surf_usm_h(l)%qsws_veg_av(1:surf_usm_h(l)%ns) )
+                    surf_usm_h(l)%qsws_veg_av = 0.0_wp
                 ELSE
                    IF ( .NOT.  ALLOCATED( surf_usm_v(l)%qsws_veg_av ) )  THEN
@@ -1480,7 +1432,7 @@
 !--             Array of latent heat flux from surfaces with liquid
 !--             Land surfaces
-                IF ( l == -1 .AND. .NOT.  ALLOCATED( surf_usm_h%qsws_liq_av ) )  THEN
-                    ALLOCATE ( surf_usm_h%qsws_liq_av(1:surf_usm_h%ns) )
-                    surf_usm_h%qsws_liq_av = 0.0_wp
+                IF ( horizontal .AND. .NOT.  ALLOCATED( surf_usm_h(l)%qsws_liq_av ) )  THEN
+                    ALLOCATE ( surf_usm_h(l)%qsws_liq_av(1:surf_usm_h(l)%ns) )
+                    surf_usm_h(l)%qsws_liq_av = 0.0_wp
                 ELSE
                    IF ( .NOT.  ALLOCATED( surf_usm_v(l)%qsws_liq_av ) )  THEN
@@ -1496,8 +1448,8 @@
 !
 !--             Array of heat flux from ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%wghf_eb_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%wghf_eb_av(1:surf_usm_h%ns) )
-                       surf_usm_h%wghf_eb_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%wghf_eb_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%wghf_eb_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%wghf_eb_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1511,8 +1463,8 @@
 !
 !--             Array of heat flux from window ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%wghf_eb_window_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%wghf_eb_window_av(1:surf_usm_h%ns) )
-                       surf_usm_h%wghf_eb_window_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%wghf_eb_window_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%wghf_eb_window_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%wghf_eb_window_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1526,8 +1478,8 @@
 !
 !--             Array of heat flux from green ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%wghf_eb_green_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%wghf_eb_green_av(1:surf_usm_h%ns) )
-                       surf_usm_h%wghf_eb_green_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%wghf_eb_green_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%wghf_eb_green_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%wghf_eb_green_av = 0.0_wp
                    ENDIF
                 ELSE
